#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>

#include "general.h"

int num_of_cores();
int get_num_of_faulty_configurations(Params *params);
Params *inst_params();
void free_params(Params *params);
Resource*** compute_faulty_resources(const Params *params);
int run_algorithm_on_faulty_configuration(Resource** faulty_resources, const Params *params, int desc);
struct RET_table run_algorithm_on_batch_of_faulty_configurations(int start, int end, const Params *params);
int inst_num_of_resources(const Params *params);

//#include <google/heap-profiler.h>

int main() {
    //HeapProfilerStart("heap.profile");
    Params *params = inst_params();
    /*
    //Resource*** list_of_frs = compute_faulty_resources(params);
    run_algorithm_on_faulty_configuration(list_of_frs[0], params, 0);
    int i;
    for (i=inst_num_of_resources(params)-1; i >= 0; i--) {
        if (list_of_frs[i] != NULL) {
            int j = 0;
            while (list_of_frs[i][j] != NULL)
                free(list_of_frs[i][j++]);
            free(list_of_frs[i]);
        }
    }
    free(list_of_frs);
     */
	struct RET_table ret_t = {0,0,0,false};
	run_algorithm_on_batch_of_faulty_configurations(0, 1, &ret_t, params);
    delete params;
    //HeapProfilerStop();

    //fprintf(stderr, "pause\n");
    //pause();

    return 0;
}
